#line 1 "emacdriver.c"
























 

#line 1 "emacdriver.h"
























 




#line 1 "types.h"
























 





typedef char SCHAR ;
typedef unsigned char UCHAR ;
typedef short int SSHORT ;
typedef unsigned short int USHORT ;
typedef long int SLONG ;
typedef unsigned long ULONG ;





#line 31 "emacdriver.h"







typedef struct {
                 UCHAR                DestinMACAddress [ 6 ] ;   
                 UCHAR                SourceMACAddress [ 6 ] ;   
                 USHORT               LengthOrType ;                             
               } EtherPackedHeaderRecT ;                                         












typedef struct {
                 ULONG         Length ;
                 ULONG         Index ;

                 UCHAR         Data [ ] ;
               } OSFrameRecT ;
typedef OSFrameRecT * PtrOSFrameRecT ;

typedef enum { Mode_10MBIT , Mode_100MBIT , Mode_AutoNeg } EtherSpeedMode ;




typedef ULONG ( * SendFrameServiceProcT ) ( OSFrameRecT *   ) ;
                                         
                                         
typedef void ( * FrameServiceProcT ) ( OSFrameRecT *   ) ;

typedef PtrOSFrameRecT ( * AllocFrameMemoryProcT ) ( ULONG   ) ;
                                         

typedef void ( * DeallocFrameMemoryProcT ) ( PtrOSFrameRecT   ) ;

typedef void ( * VoidServiceProcT ) ( void ) ;

typedef struct {
                 UCHAR                   InterfaceMACAddress [ 6 ] ;
                 VoidServiceProcT        CheckEthInterface ;                 
                 FrameServiceProcT       InterfaceProcessFrame ;             
                 AllocFrameMemoryProcT   InterfaceAllocFrameMemory ;         
                 DeallocFrameMemoryProcT InterfaceDeallocFrameMemory ;       
                 SendFrameServiceProcT   InterfaceSendFrame ;                
               } EMACInstanceRecT ;
typedef EMACInstanceRecT * PtrEMACInstanceRecT ;
							 
extern EMACInstanceRecT EMACInstanceRec ;

extern EMACInstanceRecT * InitPHYLayerInstance ( UCHAR *          ,
                                                 EtherSpeedMode   ) ;

#line 28 "emacdriver.c"
#line 1 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


















 




 
#line 36 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 69 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 
#line 104 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 138 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"




 
#line 155 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 166 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 177 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 

















 
#line 203 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

























 























































































































































































 


 




 





 



 






	
 





 


 


 



 


 










 





 
#line 489 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 498 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 507 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 515 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 523 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 531 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"



	
 
#line 554 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 574 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 594 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 614 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 
#line 639 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 662 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 
#line 680 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 698 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 715 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 732 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 742 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 752 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 762 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 770 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 783 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 796 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 
#line 827 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 
#line 843 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 




 
#line 857 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 868 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"






#line 887 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"
  	
#line 900 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 914 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"
  	
#line 927 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 
#line 950 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 
#line 964 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 
#line 982 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 






 







 





 






 






 




 



 






 
#line 1053 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 1079 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 1087 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 1095 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"






 
#line 1117 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"





#line 1134 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


























#line 29 "emacdriver.c"
#line 30 "emacdriver.c"


























 












                                         
#line 80 "emacdriver.c"

                                         
#line 93 "emacdriver.c"

                                         
#line 108 "emacdriver.c"

                                         





                                         






                                         




                                         
#line 136 "emacdriver.c"

                                         
#line 148 "emacdriver.c"

                                         



                                         
#line 161 "emacdriver.c"

                                         



                                         




                                         








                                         



                                         



                                         
#line 206 "emacdriver.c"

                                         



                                         
#line 228 "emacdriver.c"

                                         



                                         


                                         
#line 245 "emacdriver.c"

                                         


                                         



                                         
#line 269 "emacdriver.c"


                                         
#line 280 "emacdriver.c"






























































 


#line 365 "emacdriver.c"















































































































































































































































































































































































































 

#line 775 "emacdriver.c"




























































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































 


typedef struct {               
                 ULONG   Packet ;
                 ULONG   Control ;
               } RxDescriptor_RecT ;
typedef struct {               
                 ULONG   StatusInfo ;
                 ULONG   StatusHashCRC ;
               } RxStatus_RecT ;
typedef struct {               
                 ULONG   Packet ;
                 ULONG   Control ;
               } TxDescriptor_RecT ;
typedef struct {               
                 ULONG   StatusInfo ;
               } TxStatus_RecT ;

#line 2012 "emacdriver.c"


EMACInstanceRecT EMACInstanceRec ;


static void PoolEthInterface ( void )
{
  ULONG RxDataLength ;
  ULONG Index ;
  ULONG FrameStatus ;
  ULONG * SourcePointer ;
  ULONG * DestinationPointer ;
  PtrOSFrameRecT Frame ;
  RxDescriptor_RecT * WorkRxDescr ;
  RxStatus_RecT * WorkRxStatus ;
   
  if ( (*(volatile unsigned long *)(0xFFE00000 + 0x114)) != (*(volatile unsigned long *)(0xFFE00000 + 0x118)) )
  {
    Index = (*(volatile unsigned long *)(0xFFE00000 + 0x118)) ;
    WorkRxDescr = ( RxDescriptor_RecT * ) 0x7FE00000 ;
    WorkRxDescr += Index ;
    WorkRxStatus = ( RxStatus_RecT * ) ( 0x7FE00000 + 4 * sizeof ( RxDescriptor_RecT ) ) ;
    WorkRxStatus += Index ;
    FrameStatus = WorkRxStatus -> StatusInfo ;
    RxDataLength = ( FrameStatus & 0x000007FF ) - 3 ;
    if ( RxDataLength > 1536 )
    {
      Frame = ( void * ) 0 ;
    }  
    else
    {
      Frame = EMACInstanceRec . InterfaceAllocFrameMemory ( RxDataLength ) ;
      if ( Frame )
      {
        DestinationPointer = ( ULONG * ) ( & Frame -> Data [ 0 ] ) ;
        Frame -> Length = RxDataLength ;
        Frame -> Index = 0 ;
        SourcePointer = ( ULONG * ) WorkRxDescr -> Packet ;
        RxDataLength = ( RxDataLength + 3 ) >> 2 ;
        for ( ; RxDataLength ; RxDataLength -- )
          * DestinationPointer ++ = * SourcePointer ++ ;
      }   ;
    }   ;
    Index = (*(volatile unsigned long *)(0xFFE00000 + 0x118)) ;
    if ( ++ Index == 4 )
      Index = 0 ;
    (*(volatile unsigned long *)(0xFFE00000 + 0x118)) = Index ;
		if ( Frame )
      EMACInstanceRec . InterfaceProcessFrame ( Frame ) ;
  }   ;
}  


static void IgnoreFrame ( PtrOSFrameRecT Frame )
{
   
  EMACInstanceRec . InterfaceDeallocFrameMemory ( Frame ) ;
}  


static PtrOSFrameRecT DefaultAllocation ( ULONG Size )
{
   
  return ( ( OSFrameRecT * ) 0 ) ;
}  


static void DefaultDeallocation ( PtrOSFrameRecT Frame )
{
   
}  


static ULONG EMACSendFrame ( PtrOSFrameRecT Frame )
{
  ULONG Index ;
  ULONG Length ;
  ULONG * SourcePointer ;
  ULONG * DestinationPointer ;
  TxDescriptor_RecT * TxDescr ;
   
  while ( Frame -> Length < 64 )
  {
    Frame -> Data [ Frame -> Length ++ ] = 0x00 ;
  }   ;
  Index = (*(volatile unsigned long *)(0xFFE00000 + 0x128)) ;
  SourcePointer  = ( ULONG * ) ( & Frame -> Data [ 0 ] ) ;
  TxDescr = ( TxDescriptor_RecT * ) ( ( 0x7FE00000 + 4 * sizeof ( RxDescriptor_RecT ) ) + 4 * sizeof ( RxStatus_RecT ) ) ;
  TxDescr += Index ;
  DestinationPointer  = ( ULONG * ) TxDescr -> Packet ;
  Length = ( Frame -> Length + 3 ) >> 2 ;
  for ( ; Length ; Length -- )
    * DestinationPointer ++ = * SourcePointer ++ ;
  TxDescr -> Control = ( Frame -> Length - 1 ) | 0x40000000 ;
                                            
                                            
  Index = (*(volatile unsigned long *)(0xFFE00000 + 0x128)) ;
  if ( ++ Index == 6 )
    Index = 0 ;
  (*(volatile unsigned long *)(0xFFE00000 + 0x128)) = Index ;
  return ( 0 ) ;
}  


static void InitEMACDescr ( void )
{
  ULONG Loop ;
  ULONG BufferAddress ;
  RxDescriptor_RecT * WorkRxDescr ;
  RxStatus_RecT * WorkRxStatus ;
  TxDescriptor_RecT * WorkTxDescr ;
  TxStatus_RecT * WorkTxStatus ;
   
  WorkRxDescr = ( RxDescriptor_RecT * ) 0x7FE00000 ;
  WorkRxStatus = ( RxStatus_RecT * ) ( 0x7FE00000 + 4 * sizeof ( RxDescriptor_RecT ) ) ;
  WorkTxDescr = ( TxDescriptor_RecT * ) ( ( 0x7FE00000 + 4 * sizeof ( RxDescriptor_RecT ) ) + 4 * sizeof ( RxStatus_RecT ) ) ;
  WorkTxStatus = ( TxStatus_RecT * ) ( ( ( 0x7FE00000 + 4 * sizeof ( RxDescriptor_RecT ) ) + 4 * sizeof ( RxStatus_RecT ) ) + 6 * sizeof ( TxDescriptor_RecT ) ) ;
  BufferAddress = ( ( ( ( 0x7FE00000 + 4 * sizeof ( RxDescriptor_RecT ) ) + 4 * sizeof ( RxStatus_RecT ) ) + 6 * sizeof ( TxDescriptor_RecT ) ) + 6 * sizeof ( TxStatus_RecT ) ) ;
  for ( Loop = 0 ; Loop < 4 ; Loop ++ )
  {                              
    WorkRxDescr -> Packet = BufferAddress ;
    WorkRxDescr -> Control = ( ULONG ) 0x80000000 | ( 1536 - 1 ) ;
    WorkRxStatus -> StatusInfo = 0 ;
    WorkRxStatus -> StatusHashCRC = 0 ;
    BufferAddress += 1536 ;
    WorkRxDescr ++ ;
    WorkRxStatus ++ ;
  }   ;
  BufferAddress = ( ( ( ( ( 0x7FE00000 + 4 * sizeof ( RxDescriptor_RecT ) ) + 4 * sizeof ( RxStatus_RecT ) ) + 6 * sizeof ( TxDescriptor_RecT ) ) + 6 * sizeof ( TxStatus_RecT ) ) + 4 * 1536 ) ;
  for ( Loop = 0 ; Loop < 6 ; Loop ++ )
  {                              
    WorkTxDescr -> Packet = BufferAddress ;
    WorkTxDescr -> Control = 0 ;
    WorkTxStatus -> StatusInfo = 0 ;
    BufferAddress += 1536 ;
    WorkTxDescr ++ ;
    WorkTxStatus ++ ;
  }   ;
  (*(volatile unsigned long *)(0xFFE00000 + 0x108)) = 0x7FE00000 ;            
  (*(volatile unsigned long *)(0xFFE00000 + 0x10C)) = ( 0x7FE00000 + 4 * sizeof ( RxDescriptor_RecT ) ) ;               
  (*(volatile unsigned long *)(0xFFE00000 + 0x110)) = 4 - 1 ;     
  (*(volatile unsigned long *)(0xFFE00000 + 0x118)) = 0 ;                       
  (*(volatile unsigned long *)(0xFFE00000 + 0x11C)) = ( ( 0x7FE00000 + 4 * sizeof ( RxDescriptor_RecT ) ) + 4 * sizeof ( RxStatus_RecT ) ) ;            
  (*(volatile unsigned long *)(0xFFE00000 + 0x120)) = ( ( ( 0x7FE00000 + 4 * sizeof ( RxDescriptor_RecT ) ) + 4 * sizeof ( RxStatus_RecT ) ) + 6 * sizeof ( TxDescriptor_RecT ) ) ;               
  (*(volatile unsigned long *)(0xFFE00000 + 0x124)) = 6 - 1 ;     
  (*(volatile unsigned long *)(0xFFE00000 + 0x128))  = 0 ;                      
}  


static void WriteToPHY ( ULONG  PhyRegisterSelector ,
                         USHORT Value )
{
  ULONG TimeOutLoop ;
   
  (*(volatile unsigned long *)(0xFFE00000 + 0x028)) = 0x0100 | PhyRegisterSelector ;    
  (*(volatile unsigned long *)(0xFFE00000 + 0x02C)) = Value ;                                     
  for ( TimeOutLoop = 0 ; TimeOutLoop < 0x00050000 ; TimeOutLoop ++ )
  {
    if ( ( (*(volatile unsigned long *)(0xFFE00000 + 0x034)) & 0x00000001 ) == 0 )
     break ;
  }   ;
}  


static USHORT ReadFromPHY ( ULONG PhyRegisterSelector )
{
  ULONG TimeOutLoop ;
   
  (*(volatile unsigned long *)(0xFFE00000 + 0x028)) = 0x0100 | PhyRegisterSelector ;    
  (*(volatile unsigned long *)(0xFFE00000 + 0x024)) = 0x00000001 ;                                 
  for ( TimeOutLoop = 0 ; TimeOutLoop < 0x00050000 ; TimeOutLoop ++ )
  {
    if ( ( (*(volatile unsigned long *)(0xFFE00000 + 0x034)) & 0x00000001 ) == 0 )
      break ;
  }   ;
  (*(volatile unsigned long *)(0xFFE00000 + 0x024)) = 0 ;
  return ( (*(volatile unsigned long *)(0xFFE00000 + 0x030)) ) ;                                 
}  


EMACInstanceRecT * InitPHYLayerInstance ( UCHAR *        MACAddress ,
                                          EtherSpeedMode SpeedMode )
{
  ULONG Loop ;
  ULONG RegisterValue ;
  ULONG Ident1 ;
  ULONG Ident2 ;
   
  EMACInstanceRec . CheckEthInterface = PoolEthInterface ;
  EMACInstanceRec . InterfaceProcessFrame = IgnoreFrame ;
  EMACInstanceRec . InterfaceAllocFrameMemory = DefaultAllocation ;
  EMACInstanceRec . InterfaceDeallocFrameMemory = DefaultDeallocation ;
  EMACInstanceRec . InterfaceSendFrame = EMACSendFrame ;
  for ( Loop = 0 ; Loop < 6 ; Loop ++ )
    EMACInstanceRec . InterfaceMACAddress [ Loop ] = * MACAddress ++ ;
  (*(volatile unsigned long *)(0xE01FC000 + 0x0C4)) |= 0x40000000 ;                                      
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
  if ( (*(volatile unsigned long *)(0xFFE00000 + 0xFFC)) == 0x39022000 )
	{ 
     
    (*(volatile unsigned long *)(0xE002C000 + 0x08)) = 0x50151105 ;
  }  
  else
	{
     
    (*(volatile unsigned long *)(0xE002C000 + 0x08)) = 0x50150105 ;
  }   ;
  (*(volatile unsigned long *)(0xE002C000 + 0x0C)) = ( (*(volatile unsigned long *)(0xE002C000 + 0x0C)) & ( ~ 0x0000000F ) ) | 0x00000005 ;
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
                                 
  (*(volatile unsigned long *)(0xFFE00000 + 0x000)) = 0x00000100 | 0x00000200 | 0x00000400 | 0x00000800 |
             0x00004000 | 0x00008000 ;              
  (*(volatile unsigned long *)(0xFFE00000 + 0x100)) = 0x00000008 | 0x00000010 | 0x00000020 ;     
                                                         
                                                         
                                                         
  for ( Loop = 200 ; Loop ; Loop -- )                    
  {
    __asm ("nop") ;
  }   ;
  (*(volatile unsigned long *)(0xFFE00000 + 0x000)) = 0x00000002 ;                             
  (*(volatile unsigned long *)(0xFFE00000 + 0x004)) = 0x00000010 | 0x00000020 ;                 
  (*(volatile unsigned long *)(0xFFE00000 + 0x014)) = 1536 ;                                  
  (*(volatile unsigned long *)(0xFFE00000 + 0x010)) = 0x0000370F ;
  (*(volatile unsigned long *)(0xFFE00000 + 0x00C)) = 0x00000012 ;
  (*(volatile unsigned long *)(0xFFE00000 + 0x100)) = 0x00000200 | 0x00000040 ;             
  (*(volatile unsigned long *)(0xFFE00000 + 0x018)) = 0x00000800 ;                             
  for ( Loop = 100 ; Loop ; Loop -- )                    
  {
    __asm ("nop") ;
  }   ;
  (*(volatile unsigned long *)(0xFFE00000 + 0x018)) = 0 ;                                         
  WriteToPHY ( 0x00 , 0x8000 ) ;     
  for ( Loop = 0 ; Loop < 0x100000 ; Loop ++ )           
  {
    RegisterValue = ReadFromPHY ( 0x00 ) ;
    if ( ! ( RegisterValue & 0x8000 ) )                  
    {
       break;                                            
    }   ;
  }   ;
  Ident1 = ReadFromPHY ( 0x02 ) ;                
  Ident2 = ReadFromPHY ( 0x03 ) ;
  if ( ( Ident1 == 0x2000 ) && ( ( Ident2 & 0xFFF0 ) == 0x5C90 ) )
  {
    switch ( SpeedMode )
    {
      case Mode_10MBIT :
        WriteToPHY ( 0x00 , 0x0100 ) ;   
        break ;
      case Mode_100MBIT :
        WriteToPHY ( 0x00 , 0x2100 ) ;  
        break ;
      case Mode_AutoNeg :
        WriteToPHY ( 0x00 , 0x3000 ) ;    
        for ( Loop = 0 ; Loop < 0x100000 ; Loop ++ )        
        {
          RegisterValue = ReadFromPHY ( 0x01 ) ;
          if ( RegisterValue & 0x0020 )
          {
            break ;                                         
          }   ;
        }   ;
        break ;
      default :
        WriteToPHY ( 0x00 , 0x0100 ) ;   
    }   ;
  }   ;
  for ( Loop = 0 ; Loop < 0x100000 ; Loop ++ )              
  {
    RegisterValue = ReadFromPHY ( 0x10 ) ;
    if ( RegisterValue & 0x0001 )
    {
       break ;                                              
    }   ;
  }   ;
  if ( RegisterValue & 0x0004 )
  {
    (*(volatile unsigned long *)(0xFFE00000 + 0x004)) |= 0x00000001 ;
    (*(volatile unsigned long *)(0xFFE00000 + 0x100)) |= 0x00000400 ;
    (*(volatile unsigned long *)(0xFFE00000 + 0x008)) = 0x00000015 ;
  }  
  else
  {
    (*(volatile unsigned long *)(0xFFE00000 + 0x008)) = 0x00000012 ;
  }   ;
  if ( RegisterValue & 0x0002 )
  {
    (*(volatile unsigned long *)(0xFFE00000 + 0x018)) = 0 ;                                          
  }  
  else
  {
    (*(volatile unsigned long *)(0xFFE00000 + 0x018)) = 0x00000100 ;                                 
  }   ;
                                                            
  (*(volatile unsigned long *)(0xFFE00000 + 0x040)) = ( ( ULONG ) EMACInstanceRec . InterfaceMACAddress [ 1 ] << 8 ) |
              ( ULONG ) EMACInstanceRec . InterfaceMACAddress [ 0 ] ;
  (*(volatile unsigned long *)(0xFFE00000 + 0x044)) = ( ( ULONG ) EMACInstanceRec . InterfaceMACAddress [ 3 ] << 8 ) |
              ( ULONG ) EMACInstanceRec . InterfaceMACAddress [ 2 ] ;
  (*(volatile unsigned long *)(0xFFE00000 + 0x048)) = ( ( ULONG ) EMACInstanceRec . InterfaceMACAddress [ 5 ] << 8 ) |
              ( ULONG ) EMACInstanceRec . InterfaceMACAddress [ 4 ] ;
  InitEMACDescr ( ) ;
  (*(volatile unsigned long *)(0xFFE00000 + 0x200)) = 0x00000001 | 0x00000002 | 0x00000020 ;
                                                       
  (*(volatile unsigned long *)(0xFFE00000 + 0xFE4)) = 0 ;                                  

  (*(volatile unsigned long *)(0xFFE00000 + 0x100)) |= ( 0x00000001 | 0x00000002 ) ;             
                                                       
                                                       
  (*(volatile unsigned long *)(0xFFE00000 + 0x000)) |= 0x00000001 ;                            
  return ( & EMACInstanceRec ) ;
}  


