/*
****************************************************************************
****************************************************************************
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                                                                        **
**                           BIALYSTOK 2018                               **
**                                                                        **
**                          MODULE HTTPService                            **
**                                                                        **
**                     Mikrokontroler ARM: LPC2378                        **
**                                                                        **
**                     Wersja z dnia : 2018.06.12                         **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/


#ifndef _httpservise_
#define _httpservise_

#include "types.h"
#include "tcpservice.h"

extern USHORT TCPConnectOperation ( PtrTCPSocketDescriptionRecT /* TCPSocket     */ ,
                                    ULONG                       /* RemoteAddress */ ,
                                    USHORT                      /* RemotePort    */ ) ;

extern void TCPRecvOperation ( PtrTCPSocketDescriptionRecT /* TCPSocket       */ ,
                               ULONG                       /* SenderIPAddress */ ,
                               USHORT                      /* SenderPortNo    */ ,
                               ULONG                       /* DestIPAddress   */ ,
                               USHORT                      /* DestPortNo      */ ,
                               void *                      /* DataBuffer      */ ,
                               USHORT                      /* DataBufferSize  */ ) ;

extern void TCPEstablishOperation ( PtrTCPSocketDescriptionRecT /* TCPSocket */ ) ;

extern void TCPCloseOperation ( PtrTCPSocketDescriptionRecT /* TCPSocket */ ) ;

extern void InitWebService ( void ) ;

#endif
