/*
****************************************************************************
****************************************************************************
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                                                                        **
**                           BIALYSTOK 2007                               **
**                                                                        **
**                      MODULE ICMP Protocol Service                      **
**                                                                        **
**                     Mikrokontroler ARM: LPC2378                        **
**                                                                        **
**                     Wersja z dnia : 2007.03.22                         **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/


#ifndef _icmp_service_
#define _icmp_service_

#include "types.h"
#include "ipservice.h"

extern void ProcessICMPPacked ( PtrIPLayerInstanceRecT /* IPLayerInstance */ ,
                                IPHeaderRecT *         /* IPHeader        */ ,
                                PtrOSFrameRecT         /* Frame           */ ) ;

extern void SetICMPEchoService ( IPLayerInstanceRecT *    /* IPLayerInstance */ ,
                                 ProcessProtPServiceProcT /* EchoService     */ ) ;

extern void SendPingTo ( IPLayerInstanceRecT * /* IPLayerInstance */ ,
                         ULONG                 /* IPAddress       */ ,
                   const UCHAR *               /* Data            */ ) ;

#endif
