/*
****************************************************************************
****************************************************************************
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                           BIALYSTOK 2007                               **
**                                                                        **
**                    MODULE LPC2378 IRQ descriptions                     **
**                                                                        **
**                     Mikrokontroler ARM: LPC2378                        **
**                                                                        **
**                     Wersja z dnia : 2007.03.25                         **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/
#ifndef _ieqvectors_
#define _ieqvectors_

#define	WDT_Interrupt           0

#define ARM_CORE0_Interrupt     2
#define ARM_CORE1_Interrupt     3
#define TIMER0_Interrupt        4
#define TIMER1_Interrupt        5
#define UART0_Interrupt         6
#define UART1_Interrupt         7
#define PWM0_Interrupt          8
#define I2C0_Interrupt          9
#define SSP0_Interrupt         10
#define SSP1_Interrupt         11
#define PLL_Interrupt          12
#define RTC_Interrupt          13
#define EINT0_Interrupt        14
#define EINT1_Interrupt        15
#define EINT2_Interrupt        16
#define EINT3_Interrupt        17
#define ADC0_Interrupt         18
#define I2C1_Interrupt         19
#define BOD_Interrupt          20
#define EMAC_Interrupt         21
#define USB_Interrupt          22
#define CAN1_Interrupt         23
#define SD_Interrupt           24
#define GPDMA_Interrupt        25
#define TIMER2_Interrupt       26
#define TIMER3_Interrupt       27
#define UART2_Interrupt        28
#define UART3_Interrupt        29
#define I2C2_Interrupt         30
#define I2S_Interrupt          31

#endif
