/*
****************************************************************************
****************************************************************************
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                           BIALYSTOK 2007                               **
**                                                                        **
**                           MODULE System                                **
**                                                                        **
**                     Mikrokontroler ARM: LPC2378                        **
**                                                                        **
**                     Wersja z dnia : 2007.03.22                         **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/
 
#include <LPC23xx.H>
#include "system.h"


void SysInit ( void )
{
  unsigned long Loop ;
  volatile unsigned long * Vect_Addr ;
  volatile unsigned long * Vect_Prio ;
  /*-------------------------------------------------------------------------*/
  MEMMAP = MEMMAP_FLASH ;
  VICIntEnClr  = 0xFFFFFFFF ;
  VICVectAddr  = 0x00000000 ;
  VICIntSelect = 0x00000000 ;
  for ( Loop = 0; Loop < 32 ; Loop ++ )
  {
    Vect_Addr = ( unsigned long * ) ( VIC_BASE_ADDR + VECT_ADDR_INDEX + Loop * 4 ) ;
    Vect_Prio = ( unsigned long * ) ( VIC_BASE_ADDR + VECT_PRIO_INDEX + Loop * 4 ) ;
    * Vect_Addr = 0x00000000 ;
    * Vect_Prio = 0x0000000F ;
  } /* for */ ;
//  wdtInit ( ) ;
} /* SysInit */

