/*
****************************************************************************
****************************************************************************
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                           BIALYSTOK 2007                               **
**                                                                        **
**                    MODULE LPC2378 UART0 Service                        **
**                                                                        **
**                     Mikrokontroler ARM: LPC2378                        **
**                                                                        **
**                     Wersja z dnia : 2007.03.25                         **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/

#ifndef _UART0_ 
#define _UART0_

#include "types.h"

extern UCHAR UART0TxdLEDDelayCounter ;
extern UCHAR UART0RxDLEDDelayCounter ;

extern void UART0InitEnvir ( void ) ;

extern void UART0HardwInit( ULONG /* PeriphClk   */ ,
                            UCHAR /* SerialMode  */ ,
                            ULONG /* SerialSpeed */ ) ;

extern void UART0InputReset ( void ) ;

extern void UART0Send ( UCHAR /* Data */ ) ;

extern void UART0SendString ( UCHAR * /* String */ ) ;

extern ULONG UART0DataPresent ( void ) ;

extern UCHAR UART0GetData ( void ) ;

extern UCHAR UART0Working ( void ) ;

#endif

