#line 1 "leddisplay.c"
























 

#line 1 "leddisplay.h"
























 



#line 1 "types.h"
























 





typedef char SCHAR ;
typedef unsigned char UCHAR ;
typedef short int SSHORT ;
typedef unsigned short int USHORT ;
typedef long int SLONG ;
typedef unsigned long ULONG ;





#line 31 "leddisplay.h"

typedef enum { StatusLED       ,
               UART0TxDLED     ,
               UART0RxDLED     ,
               UART1TxDLED     ,
               UART1RxDLED     ,
               HTTPConnectLED  ,
               DataErrorLED    } LEDSymbolType ;

extern void LEDOn ( LEDSymbolType   ) ;
               
extern void LEDOff ( LEDSymbolType   ) ;

extern void InitLEDEnvir ( void ) ;

#line 28 "leddisplay.c"
#line 1 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


















 




 
#line 36 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 69 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 
#line 104 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 138 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"




 
#line 155 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 166 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 177 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 

















 
#line 203 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

























 























































































































































































 


 




 





 



 






	
 





 


 


 



 


 










 





 
#line 489 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 498 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 507 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 515 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 523 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 531 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"



	
 
#line 554 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 574 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 594 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 614 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 
#line 639 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 662 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 
#line 680 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 698 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 715 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 732 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 742 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 752 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 762 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 770 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 783 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 796 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 
#line 827 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 
#line 843 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 




 
#line 857 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 868 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"






#line 887 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"
  	
#line 900 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 914 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"
  	
#line 927 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 
#line 950 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 
#line 964 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


 
#line 982 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 






 







 





 






 






 




 



 






 
#line 1053 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 1079 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

 
#line 1087 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"

#line 1095 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"






 
#line 1117 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"





#line 1134 "C:\\Keil\\ARM\\Inc\\Philips\\LPC23xx.H"


























#line 29 "leddisplay.c"
























 

#line 63 "leddisplay.c"


void LEDOn ( LEDSymbolType LEDSymbol )
{
   
  switch ( LEDSymbol )
  {
    case StatusLED       :
      (*(volatile unsigned long *)(0xE0028000 + 0x1C)) = ( ULONG ) 1 << 29 ;
      break ;
    case UART0TxDLED     :
      (*(volatile unsigned long *)(0xE0028000 + 0x1C)) = ( ULONG ) 1 << 28 ;
      break ;
    case UART0RxDLED     :
      (*(volatile unsigned long *)(0xE0028000 + 0x1C)) = ( ULONG ) 1 << 27 ;
      break ;
    case UART1TxDLED     :
      (*(volatile unsigned long *)(0xE0028000 + 0x1C)) = ( ULONG ) 1 << 26 ;
      break ;
    case UART1RxDLED     :
      (*(volatile unsigned long *)(0xE0028000 + 0x1C)) = ( ULONG ) 1 << 25 ;
      break ;
    case HTTPConnectLED  :
      (*(volatile unsigned long *)(0xE0028000 + 0x1C)) = ( ULONG ) 1 << 24 ;
      break ;
    case DataErrorLED    :
      (*(volatile unsigned long *)(0xE0028000 + 0x1C)) = ( ULONG ) 1 << 23 ;
      break ;
  }   ;
}  


void LEDOff ( LEDSymbolType LEDSymbol )
{
   
  switch ( LEDSymbol )
  {
    case StatusLED       :
      (*(volatile unsigned long *)(0xE0028000 + 0x14)) = ( ULONG ) 1 << 29 ;
      break ;
    case UART0TxDLED     :
      (*(volatile unsigned long *)(0xE0028000 + 0x14)) = ( ULONG ) 1 << 28 ;
      break ;
    case UART0RxDLED     :
      (*(volatile unsigned long *)(0xE0028000 + 0x14)) = ( ULONG ) 1 << 27 ;
      break ;
    case UART1TxDLED     :
      (*(volatile unsigned long *)(0xE0028000 + 0x14)) = ( ULONG ) 1 << 26 ;
      break ;
    case UART1RxDLED     :
      (*(volatile unsigned long *)(0xE0028000 + 0x14)) = ( ULONG ) 1 << 25 ;
      break ;
    case HTTPConnectLED  :
      (*(volatile unsigned long *)(0xE0028000 + 0x14)) = ( ULONG ) 1 << 24 ;
      break ;
    case DataErrorLED    :
      (*(volatile unsigned long *)(0xE0028000 + 0x14)) = ( ULONG ) 1 << 23 ;
      break ;
  }   ;
}  

               
void InitLEDEnvir ( void )
{
   
  (*(volatile unsigned long *)(0xE002C000 + 0x0C)) = (*(volatile unsigned long *)(0xE002C000 + 0x0C)) & ( ~ 0x0FFFF000 ) ;
  (*(volatile unsigned long *)(0xE0028000 + 0x18)) |= ( ( ULONG ) 1 << 29 |
              ( ULONG ) 1 << 28 |
              ( ULONG ) 1 << 27 |
              ( ULONG ) 1 << 26 |
              ( ULONG ) 1 << 25 |
              ( ULONG ) 1 << 24 |
              ( ULONG ) 1 << 23 |
              ( ULONG ) 1 << 22 ) ;
  (*(volatile unsigned long *)(0xE0028000 + 0x14)) |= ( ( ULONG ) 1 << 29 |
              ( ULONG ) 1 << 28 |
              ( ULONG ) 1 << 27 |
              ( ULONG ) 1 << 26 |
              ( ULONG ) 1 << 25 |
              ( ULONG ) 1 << 24 |
              ( ULONG ) 1 << 23 |
              ( ULONG ) 1 << 22 ) ;
}  
