/*
****************************************************************************
****************************************************************************
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                                                                        **
**                           BIALYSTOK 2018                               **
**                                                                        **
**                          MODULE LEDService                             **
**                                                                        **
**                     Mikrokontroler ARM: LPC2378                        **
**                                                                        **
**                     Wersja z dnia : 2018.06.12                         **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/

#ifndef _ledservice_

#define _ledservice_
#include "types.h"

typedef enum { StatusLED       ,
               UART0TxDLED     ,
               UART0RxDLED     ,
               UART1TxDLED     ,
               UART1RxDLED     ,
               HTTPConnectLED  ,
               DataErrorLED    } LEDSymbolType ;

extern void LEDOn ( LEDSymbolType /* LEDSymbol */ ) ;
               
extern void LEDOff ( LEDSymbolType /* LEDSymbol */ ) ;

extern void InitLEDEnvir ( void ) ;

#endif
